<template>
	<div class="common-page device-manage">

    	<!-- 表格 -->
		<div class="panel-bottom page-row">
			<h3>区域信息管理</h3>
			<div class="ctin-box">
				<div class="content-within">
					<div class="content-fix">
						<div class="toolbar">
							<el-button size="mini" type="primary" icon="el-icon-plus" @click="toAdd">新增</el-button>
						</div>
						<div class="content">
							<el-table :data="tableData" v-loading="loading" border style="width:auto" :row-class-name="tableRowClassName">
								<el-table-column prop="code" label="编码" align="center"></el-table-column>
								<el-table-column prop="name" label="区域名称" align="center"></el-table-column>
								<el-table-column prop="areaclass" label="所属类别" align="center"></el-table-column>
								<el-table-column prop="coordinate" label="中心坐标" align="center"></el-table-column>
								<el-table-column prop="card" label="车辆标识图" align="center">
									<template slot-scope="scope">
										<img :src="imgSrcStart + '/avatar/' + scope.row.card" width="40" height="40"/>
									</template>
								</el-table-column>
								<el-table-column prop="max" label="最大承接量" align="center"></el-table-column>
								<el-table-column prop="createTime" label="日期" align="center"></el-table-column>
								<el-table-column label="操作" align="center" fixed="right">
									<template slot-scope="scope">
										<el-button size="mini" type="primary" icon="el-icon-edit" @click="toEdit(scope.row)"></el-button>
										<el-button size="mini" type="danger" icon="el-icon-delete" @click="toDelete(scope.row)"></el-button>
										<el-button size="mini" type="success" icon="el-icon-view" v-show="scope.row.areaore == '是'" @click="showGradeTable(scope.row)"></el-button>
									</template>
								</el-table-column>
							</el-table>
							<!--分页组件-->
							<el-pagination :total="total" :current-page="page" style="margin-top: 8px;" layout="total, prev, pager, next, sizes" @size-change="sizeChange" @current-change="pageChange" />
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- 表单渲染 -->
		<el-dialog append-to-body :close-on-click-modal="true" :before-close="cancelForm" :visible.sync="form.visible" :title="form.title" width="700px">
			<el-form :model="form.item" :rules="rules" ref="form1" :inline="true" size="small" label-width="150px">
				<el-form-item label="编码" prop="code">
					<el-input v-model="form.item.code" style="width:160px;" placeholder="请输入编码"/>
				</el-form-item>
				<el-form-item label="所属类别" prop="areaclass">
					<el-select v-model="form.item.areaclass" placeholder="请选择所属类别" size="small" style="width:160px;">
						<el-option v-for="(obj,index) in RegionalTypeData" :label="obj.classname" :value="obj.classname" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="区域名称" prop="name">
					<el-input v-model="form.item.name" style="width:160px;" placeholder="请输入区域名称"/>
				</el-form-item>
				<el-form-item label="是否需要遮罩层" prop="shadow">
					<el-select v-model="form.item.shadow" placeholder="请选择是否需要遮罩层" style="width:160px;">
						<el-option label="是" value="是"></el-option>
						<el-option label="否" value="否"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="最大承接车辆数" prop="max">
					<el-input v-model="form.item.max" style="width:160px;" placeholder="请输入最大承接车辆数"/>
				</el-form-item>
				<el-form-item label="区域中心坐标点" prop="coordinate">
					<el-input v-model="form.item.coordinate" style="width:160px;" placeholder="请输入区域中心坐标点"/>
				</el-form-item>
				<el-form-item label="区域标记">
					<el-input v-model="picFileName" style="width:160px;" placeholder="请上传区域标记" disabled />
					<input type="file" name="image" @change="excelImport($event)" />
				</el-form-item>
				<el-form-item label="区域范围或直径" prop="arearange">
					<el-input v-model="form.item.arearange" style="width:160px;" placeholder="请输入区域范围或直径"/>
				</el-form-item>
				<el-form-item label="电铲名称" prop="areashovel">
					<el-input v-model="form.item.areashovel" style="width:160px;" placeholder="请输入电铲名称"/>
				</el-form-item>
				<el-form-item label="矿种" prop="arearesources">
					<el-select v-model="form.item.arearesources" placeholder="请选择矿种" style="width:160px;">
						<el-option label="废石" value="废石"></el-option>
						<el-option label="矿石" value="矿石"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="是否配矿" prop="areaore">
					<el-select v-model="form.item.areaore" placeholder="请选择是否配矿" style="width:160px;">
						<el-option label="是" value="是"></el-option>
						<el-option label="否" value="否"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="优先级" prop="areapriority">
					<el-input-number v-model="form.item.areapriority" :min="1" :max="10" label="请选择优先级"></el-input-number>
				</el-form-item>


				<!-- 如果所属类型是电子围栏，要添加一下属性 -->
				<el-form-item label="启用时间段" v-show="form.item.areaclass == '电子围栏'">
					<el-time-picker
						v-model="form.item.startTime"
						placeholder="开始时间">
					</el-time-picker>
					<el-time-picker
						v-model="form.item.endTime"
						placeholder="结束时间">
					</el-time-picker>
				</el-form-item>
				<el-form-item label="限制类型" prop="limitclass" v-show="form.item.areaclass == '电子围栏'">
					<el-select v-model="form.item.limitclass" placeholder="请选择限制类型" style="width:160px;">
						<el-option label="限入" value="限入"></el-option>
						<el-option label="限出" value="限出"></el-option>
					</el-select>
				</el-form-item>
				<br/>
				<el-form-item label="选择车辆" prop="cars" v-show="form.item.areaclass == '电子围栏'">
					<div class="checkboxViews">
						<el-checkbox-group v-model="checkDataList" style="width:480px;">
							<el-checkbox v-for="(obj,index) in carInformationData" :label="obj.name + '/' + obj.number" :key="index">{{obj.name + '/' + obj.number}}</el-checkbox>
						</el-checkbox-group>
					</div>
				</el-form-item>
				<el-form-item label="启停状态" prop="status" v-show="form.item.areaclass == '电子围栏'">
					<el-select v-model="form.item.status" placeholder="请选择启停状态" style="width:160px;">
						<el-option label="启用" value="启用"></el-option>
						<el-option label="停用" value="停用"></el-option>
					</el-select>
				</el-form-item>
			</el-form>

			<div slot="footer" class="dialog-footer">
				<el-button type="text" @click="cancelForm">取消</el-button>
				<el-button :loading="form.status.cu === 2" type="primary" @click="submitForm('form1', form.item)">确认</el-button>
			</div>

		</el-dialog>

		<!-- 品位设置 -->
		<el-dialog title="品位设置" :visible.sync="dialogTableVisible">
			<div class="toolbar" style="margin-bottom:15px;">
				<el-button size="mini" type="primary" icon="el-icon-plus" @click="gradeToAdd">新增</el-button>
			</div>
			<el-table :data="gridData" border v-loading="gradeLoading">
				<el-table-column property="name" label="品位名称" align="center"></el-table-column>
				<el-table-column property="content" label="含量" align="center"></el-table-column>
				<el-table-column property="unit" label="单位" align="center"></el-table-column>
				<el-table-column label="操作" align="center" fixed="right">
					<template slot-scope="scope">
						<el-button size="mini" type="primary" icon="el-icon-edit" @click="gradeToEdit(scope.row)"></el-button>
						<el-button size="mini" type="danger" icon="el-icon-delete" @click="gradeToDelete(scope.row)"></el-button>
					</template>
				</el-table-column>
			</el-table>
		</el-dialog>

		<!-- 品位设置表单 -->
		<el-dialog :title="gradeFrom.title" :before-close="gradeCancelForm" :visible.sync="gradeFrom.visible" width="700px">
			<el-form :model="gradeFrom.item" :inline="true" ref="form2" size="small" label-width="150px">
				<el-form-item label="品位名称">
					<el-input v-model="gradeFrom.item.name" style="width:260px;" placeholder="请输入品位名称"></el-input>
				</el-form-item>
				<el-form-item label="含量">
					<el-input v-model="gradeFrom.item.content" style="width:260px;" placeholder="请输入含量"></el-input>
				</el-form-item>
				<el-form-item label="单位">
					<el-input v-model="gradeFrom.item.unit" style="width:260px;" placeholder="请输入单位"></el-input>
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="gradeCancelForm">取 消</el-button>
				<el-button :loading="gradeFrom.status.cu === 2" type="primary" @click="gradeSubmitForm('form2', gradeFrom.item)">确 定</el-button>
			</div>
		</el-dialog>

	</div>
</template>

<script>
import { Tools, HttpReq, Dates} from '@/assets/js/common.js';
import Axios from 'axios'

export default {
	name: 'CarType',
	components: {},
	data() {
		return {
			imgSrcStart:process.env.VUE_APP_LOCAL_API2,
			loading: false,
			page: 1,
			size: 10,
			total: 0,
			query:{},
			picFileName:'',
			tableData: [],
			RegionalTypeData:[],
			carInformationData:[],
			checkAll: false,
			checkDataList:[],
			oldCheckDataList:[],
			form: {
				title:'新增区域信息',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			},
			rules: {
				// time: [
				// 	{required: true, message: '请输入区域信息', trigger: 'blur' }
				// ],
			},


			//品味设置数据
			dialogTableVisible: false,
			gridData: [],
			gradeLoading: false,
			gradeQueryId:0,
			gradeFrom:{
				title:'新增品位',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			}
		}
	},
	mounted() {
		var that = this;
		this.$nextTick(() => {
			this.loadData();
		})
	},
	methods: {
		//获取区域信息数据
		loadData() {
			var sort = 'createTime,desc';
			var param = this.query;
			param.page = this.page - 1;
			param.size = this.size;
			param.sort = sort;
			
			this.$nextTick(()=>{
				HttpReq.truckDispatching.RegionalInformationQuery(param).then((res) => {
					if(res.code == 200){
						this.loading = false;
						this.tableData = res.data.content;
						this.total = res.data.totalElements;
					}
				})
				//获取所属类别
				HttpReq.truckDispatching.RegionalTypeQuery(param).then((res) => {
					if(res.code == 200){
						this.RegionalTypeData = res.data.content;
					}
				})
				//获取车辆信息
				HttpReq.truckDispatching.carInformationQuery(param).then((res) => {
					if(res.code == 200){
						this.carInformationData = res.data.content;
					}
				})
			})

		},
		tableRowClassName({row, rowIndex}) {
			if (rowIndex === 1) {
				return 'warning-row';
			} else if (rowIndex === 3) {
				return 'success-row';
			}
			return '';
		},	
		cancelForm(a, b, c){
			this.form.visible = false;
		},
		toAdd() {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '新增区域信息';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.reqType = 'add';
			this.form.item = {};
			this.picFileName = '';
			this.checkDataList = [];
		},
		toEdit(item) {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '修改区域信息';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.item = {...item};
			this.form.reqType = 'edit';
			this.picFileName = this.form.item.card;
			let oldCheckDataListCenterId = [];
			let oldCheckDataListCenterCarIn = [];
			HttpReq.truckDispatching.RegionalInformationCarQuery({areaId:item.code}).then((res) => {
				if(res.code == 200){
					res.data.content.forEach((item)=>{
						oldCheckDataListCenterId.push(item.id);
						oldCheckDataListCenterCarIn.push(item.car);
					})
				}
			})
			this.checkDataList = oldCheckDataListCenterCarIn;
			this.oldCheckDataList = oldCheckDataListCenterId;
		},
		toDelete(item) {
			var id = item.id;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.reqRemoveProject([id])
			}).catch((e) => {})
		},
		pageChange(e) {
			this.page = e
			this.loadData()
		},
		sizeChange(e) {
			this.page = 1
			this.size = e
			this.loadData()
		},
		submitForm(validateName, item){
			if(!this.form.status.cu){
				this.form.status.cu = 2;
				this.$refs[validateName].validate(valid => {
					if(valid){
						if(this.form.reqType === 'add'){
							this.reqAddItem(this.form, item)
						}else{
							this.reqUpdateItem(this.form, item)
						}
					}else{
						this.form.status.cu = 0
					}
				});
			};
		},
		//新增区域信息
		reqAddItem(form, item){
			let lastData = {...item};
			lastData.card = this.picFileName;
			HttpReq.truckDispatching.RegionalInformationAdd(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '区域信息新增成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				form.status.cu = 0
			});

			this.checkDataList.forEach((carItem,index)=>{
				let uploadCarData = {};
				uploadCarData.car = carItem;
				uploadCarData.areaId = item.code;
				console.log('uploadCarData',uploadCarData);
				HttpReq.truckDispatching.RegionalInformationCarAdd(uploadCarData).then((res) => {
					if(res.code == 200){
					}else{
						this.$notify({
							title: res.msg,
							type: 'error',
							duration: 2500
						})
					}
				}).catch(function(error) { });
			})
		},
		//修改区域信息
		reqUpdateItem(form, item){
			let lastData = {...item};
			lastData.card = this.picFileName;
			lastData.cars = this.checkDataList;
			HttpReq.truckDispatching.RegionalInformationUpdate(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '区域信息修改成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
					this.loadData()
				}
			}).catch(function(error) {
				form.status.cu = 0
			});
			HttpReq.truckDispatching.RegionalInformationCarDel(this.oldCheckDataList).then((res) => {	})
			this.$nextTick(()=>{
				this.checkDataList.forEach((carItem,index)=>{
					let uploadCarData = {};
					uploadCarData.car = carItem;
					uploadCarData.areaId = item.code;
					HttpReq.truckDispatching.RegionalInformationCarAdd(uploadCarData).then((res) => {
						if(res.code == 200){
						}else{
							this.$notify({
								title: res.msg,
								type: 'error',
								duration: 2500
							})
						}
					}).catch(function(error) { });
				})
			})
		},
		//删除区域信息
		reqRemoveProject(item){
			HttpReq.truckDispatching.RegionalInformationDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadData();
			})
		},
		//图片上传
		excelImport(event) {
			let that = this;
			let file = event.target.files[0];
			let formData1 = new FormData();
			formData1.append("avatar", file);
			Axios({
				url: process.env.VUE_APP_LOCAL_API2 + '/api/wEquipment/updateAvatar',
				method: "post",
				data: formData1,
			}).then(
				response => {
					if (response.status == 200) {
						this.$message.success("上传成功");
						that.picFileName = response.data.avatar;
					} else {
						this.$message.error("上传失败");
					}
				},
			)
			.catch(error => {
				console.log(error);
			});
		},


		//品味设置方法
		showGradeTable(row){
			this.dialogTableVisible = true;
			this.gradeQueryId = row.id;
			this.loadGradeData();
		},
		//获取品味设置数据
		loadGradeData(){
			var sort = 'id,desc';
			var param = {};
			param.sort = sort;
			param.areaId = this.gradeQueryId;
			
			this.$nextTick(()=>{
				HttpReq.truckDispatching.RegionalInformationGradeQuery(param).then((res) => {
					if(res.code == 200){
						this.gradeLoading = false;
						this.gridData = res.data.content;
					}
				})
			})
		},
		gradeCancelForm(a, b, c){
			this.gradeFrom.visible = false;
		},
		gradeSubmitForm(validateName, item){
			if(!this.gradeFrom.status.cu){
				this.gradeFrom.status.cu = 2;
				this.$refs[validateName].validate(valid => {
					if(valid){
						if(this.gradeFrom.reqType === 'add'){
							this.gradeReqAddItem(this.gradeFrom, item)
						}else{
							this.gradeReqUpdateItem(this.gradeFrom, item)
						}
					}else{
						this.gradeFrom.status.cu = 0
					}
				});
			};
		},
		gradeToAdd() {
			// 请除表单验证
			this.$refs['form2'] && this.$refs['form2'].clearValidate();
			this.gradeFrom.title = '新增品味';
			this.gradeFrom.status.cu = 0;
			this.gradeFrom.visible = true;
			this.gradeFrom.reqType = 'add';
			this.gradeFrom.item = {};
		},
		gradeToEdit(item) {
			// 请除表单验证
			this.$refs['form2'] && this.$refs['form2'].clearValidate();
			this.gradeFrom.title = '修改品位设置';
			this.gradeFrom.status.cu = 0;
			this.gradeFrom.visible = true;
			this.gradeFrom.item = {...item};
			this.gradeFrom.reqType = 'edit';
		},
		gradeToDelete(item) {
			var id = item.id;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.gradeReqRemoveProject([id])
			}).catch((e) => {})
		},
		//新增品味设置
		gradeReqAddItem(gradeFrom, item){
			let lastData = {...item};
			lastData.areaId = this.gradeQueryId;
			HttpReq.truckDispatching.RegionalInformationGradeAdd(lastData).then((res) => {
				gradeFrom.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '品味设置新增成功！',
						type: 'success',
						duration: 2500
					});
					this.loadGradeData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				gradeFrom.status.cu = 0
			});
		},
		//修改品味设置
		gradeReqUpdateItem(gradeFrom, item){
			let lastData = {...item};
			HttpReq.truckDispatching.RegionalInformationGradeUpdate(lastData).then((res) => {
				gradeFrom.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '品味设置修改成功！',
						type: 'success',
						duration: 2500
					});
					this.loadGradeData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
					this.loadGradeData()
				}
			}).catch(function(error) {
				gradeFrom.status.cu = 0
			});
		},
		//删除品味设置
		gradeReqRemoveProject(item){
			HttpReq.truckDispatching.RegionalInformationGradeDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadGradeData();
			})
		},

	}
}
</script>

<style rel="stylesheet/scss" lang="scss" scope>
	.el-table .warning-row {
		background: oldlace;
	}
	.el-table .success-row {
		background: #f0f9eb;
	}
	
	.device-manage{
		.panel-bottom{
			.el-button{margin:2px 0;padding:6px 15px;font-size:14px;}
			.btn-groub2{
				display:inline-block;
				.el-button{margin:2px 0;padding:6px 15px;font-size:15px;}
				.el-button--warning {
					background-color: #e6a23c;
					border-color: #e6a23c;
				}
				.el-button--warning:focus,.el-button--warning:hover{background:#ebb563;border-color:#ebb563;}
			}
			
		}
		
	}
	.checkboxViews{
		padding-left: 10px;
		box-sizing: border-box;
		width: 490px;
		height: 120px;
		border: 1px gainsboro solid;
		overflow-y:scroll;
		overflow-x:hidden;
	}
	.ecahrt1-dialog{
		display:flex;align-items:center;
		.el-dialog{
			margin-top:inherit !important;display:table !important;width:fit-content;
			.el-form-item{margin-right:0;}
		}

		.el-dialog__header{height:0;padding:0;display:block;}
		.form-body{
			border:1px solid #999;width:800px;height:500px;position:relative;
			>div{position:absolute;top:0;left:0;height:100%;width:100%;}
		}
	}
</style>
